function generateDescription(){
	//loop over all forms
	//read the setup
	let debug=true;
   let fName='[generateDescription]';
   if (debug)
      print(fName);

	//add object to store form related data
	config.formConfig=new Object();

	config.formConfig.softwareVersion='0.0.1';

	
	//set containers for data and configuration
	setContainer('data',LABKEY.ActionURL.getContainer());
	setContainer('config',LABKEY.ActionURL.getContainer());
	setContainer('CRF',LABKEY.ActionURL.getContainer());

	let selectRows=new Object();
	//this is local data
	selectRows.containerPath=getContainer('CRF');
	selectRows.schemaName='lists';
	selectRows.queryName='crfSettings';
	//store form related data to this object
	selectRows.success=function(data){afterSettings(data,collectLayout);};
	LABKEY.Query.selectRows(selectRows);

}

function collectLayout(){

	let queryArray=new Array();
	//users
	queryArray.push(makeQuery('CRF','users','userData',[]));
	queryArray[queryArray.length-1].schemaName='core';
	
	//Forms	
	queryArray.push(makeQuery('config','Forms','formData',[]));
	//FormSetup	
	queryArray.push(makeQuery('config','FormSetup','formSetup',[]));
	//inputLists
	queryArray.push(makeQuery('config','inputLists','inputLists',[]));
	//

	print('running getDataFromQueries');
	getDataFromQueries(queryArray,loadForms);
}

function findName(listId){
	let frows=config.formConfig.inputLists.rows;
	for (let i=0;i<frows.length;i++){
		if (frows[i]['Key']!=listId) continue;
		return frows[i]['queryName'];
	}
}

function loadForms(){
	print('loadedData');
	let queryArray=new Array();
	
	let frows=config.formConfig.formSetup.rows;
	for (let i=0;i<frows.length;i++){
		let listId=frows[i]['queryName'];
		//skip forms only
		let showFlag=frows[i]['showFlag'];
		let showQuery=frows[i]['showQuery'];
		if (showFlag=='REVIEW') continue;
		let listName=findName(listId);
		print(listName);
		queryArray.push(makeQuery('data',listName,listName,[]));
		if (showFlag=='NONE') continue;
		queryArray.push(makeQuery('data',showQuery,showQuery,[]));
	}

	getDataFromQueries(queryArray,printLayout);

}

function getList(formId){
	let fList=new Array();
	let frows=config.formConfig.formSetup.rows;
	for (let i=0;i<frows.length;i++){
		if (frows[i]['formName']!=formId) continue;
		let listId=frows[i]['queryName'];
		let showFlag=frows[i]['showFlag'];
		let showQuery=frows[i]['showQuery'];
		if (showFlag=='REVIEW') continue;
		let fObj=new Object();
		fObj['queryName']=findName(listId);
		fObj['title']=frows[i]['title'];
		fList.push(fObj);
		if (showFlag=='NONE') continue;
		let fObj1=new Object();
		fObj1['queryName']=showQuery;
		fObj1['title']=frows[i]['title']+' (details)';
		fList.push(fObj1);
	}
	return fList;
}

function printField(field){
	let name=field['name'];
	if (name=='Key') return;
	if (name=='crfRef') return;
	let type=field['type'];
	let qName='';
	if ('lookup' in field){
		qName=field.lookup.queryName;
	}
	print(name+' '+type+'/'+qName);
	printPDF(field);
}

function addLookup(lookupList,field){
	if ('lookup' in field){
		lookupList.add(field.lookup.queryName);
	}
}

function printFields(lookupList,listName){
	let fields=config.formConfig[listName].metaData.fields;
	//print('getFields '+listName+': '+fields.length);
	for (f in fields){
		printField(fields[f]);
		addLookup(lookupList,fields[f]);		
		//printPDF(fields[f]);
	}
}

function printData(){
	let frows=config.formConfig.formData.rows;
	let lookupList=new Set();
	for (let i=0;i<frows.length;i++){
		let formId=frows[i]['Key'];
		print(frows[i]['formName']);
		printTitlePDF(20,frows[i]['formName']);
		let fList=getList(formId);
		for (let j=0;j<fList.length;j++){
			print(fList[j]['queryName']);
			printTitlePDF(16,fList[j]['title']);
			printFields(lookupList,fList[j]['queryName']);
		}
	}
	print('all done');
	let queryArray=new Array();
	for (let item of lookupList){
		queryArray.push(makeQuery('data',item,item,[]));
	}
	let cb=function(){printLookup(lookupList);};
	getDataFromQueries(queryArray,cb);
}

function printQuery(queryName){
	printTitlePDF(16,queryName);
	print(queryName);
	let frows=config.formConfig[queryName].rows;
	print('rows: '+frows);
	let fields=config.formConfig[queryName].metaData.fields;
	let field=undefined;
	for (f in fields){
		if (fields[f].name=='Key') continue;
		field=fields[f];
		break;
	}
	for (let i=0;i<frows.length;i++){
		printPDFEntry(field,frows[i]);
	}
}

function printLookup(lookupList){

	printTitlePDF(20,'Enumerators');
	for (let item of lookupList){
		printQuery(item);
	}
	config.doc.end();

}

function checkBlob(){
	print("checkBlob: "+config.blob);
	if (config.blob) {
		clearInterval(config.blobInterval);
		config.a.href = config.window.URL.createObjectURL(config.blob);
		print("HREF: "+config.a.href);
		config.a.download = 'test.pdf';
		config.a.click();
		config.window.URL.revokeObjectURL(config.a.href);
	}
	config.count=config.count+1;
	print("Eval: "+config.count);
	if (config.count>100){
		clearInterval(config.blobInterval);
	}

}


function printLayout(){

	config.doc=new PDFDocument({margins: {top:20,left:50,right:100,bottom:20},paragraphGap:10});
	//config.doc.end();
	let stream = config.doc.pipe(blobStream()).on("finish",function(){
			config.blob=stream.toBlob("application/pdf");});
	
	print("BLob: "+config.blob);
	config.a = config.document.createElement("a");
	config.document.body.appendChild(config.a);
	config.a.innerHTML="Download PDF";
	config.a.style = "display: none";
	config.count=0;
	//run until blob is set
	config.blobInterval=setInterval(checkBlob,1000);

	//pick data from crfForm list
        print("Printing form");
	printData();
}

function printTitlePDF(fontSize,title){
	config.doc.y+=10;
   //x margin
   //config.doc.x=50;
	config.doc.font('Courier-Bold').fontSize(fontSize).text(title);
}

function printPDF(field){
	//object field should have a name, type, caption
	//entry should have field.name
	//lookup is null or has a lookup table LUT 
	//for value v of entry[field.name]
	//
	//the total width of a A4 page is 598 px, 
	//left margin is 72. With a right margin of 50,
	//the total available with is 476 px.

   let fName='[printPDF]';
	
	let w=676;
	let spacing=25;
	let w1=(w-spacing)*0.5;
	let fontSize=14;	
   let margin=50;
   let topMargin=20;
	
	print(fName+' entry['+field.name);
	print('printPDF: field type:'+field.type);

   config.doc.y+=10;
   let ty1=config.doc.y;


	//measure text
	let label=field.caption;
	let opt={width:w1};
	config.doc.fontSize(fontSize);
	
	//for more eloquent display the height of the text
	//can be measured prior to output
	//use currentLineHeight to scale height
	//let lineH=config.doc.currentLineHeight(1);
	//let h=config.doc.heightOfString(label,opt)/lineH;


	//print label
	config.doc.font('Courier').text(label,opt);
	
   //store x value for later use
	let tx=config.doc.x;
	let ty=config.doc.y;
   
   let height=config.doc.heightOfString(label,opt);
   let lWidth=config.doc.widthOfString(label,opt);
   
   let ypos=ty1;
   if (ty<ty1) ypos=topMargin;
   let xpos=lWidth+spacing+margin;
   if (height>2*fontSize){
      //multiline text
      ypos=0.5*(ty+ty1);
      if (ty<ty1){
         //page break
         ypos=0.5*ty;
      }
      xpos=w1+spacing+margin;
	}

	//shift for value output
	config.doc.x=xpos;
   config.doc.y=ypos;
	let v='['+field.type;
	if ('lookup' in field){
		v+='/'+field.lookup.queryName;
	}
   v+=']';
	print('v: '+v);
	config.doc.font('Courier-Bold').text(v,opt);

	//restore x value
	config.doc.x=tx;
   //set y to maximum of current and position of the label
   if (config.doc.y<ty) config.doc.y=ty;
	
}

function printPDFEntry(field,entry){
	//object field should have a name, type, caption
	//entry should have field.name
	//lookup is null or has a lookup table LUT 
	//for value v of entry[field.name]
	//
	//the total width of a A4 page is 598 px, 
	//left margin is 72. With a right margin of 50,
	//the total available with is 476 px.
	
	let w=476;
	let spacing=25;
	let w1=(w-spacing)*0.5;
	let fontSize=14;	
	
	print('printPDF: entry['+field.name);
	print('printPDF: field type:'+field.type);

	//measure text
	let label=entry[field.name];
	let opt={width:w1};
	config.doc.fontSize(fontSize);
	
	//for more eloquent display the height of the text
	//can be measured prior to output
	//use currentLineHeight to scale height
	//let lineH=config.doc.currentLineHeight(1);
	//let h=config.doc.heightOfString(label,opt)/lineH;


	//print label
	config.doc.font('Courier').text(label,opt);
	
	
}

